// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO40/legacy/DIO40_Linux_1.00.0_GSC_DN/din/dio.c $
// $Rev: 32587 $
// $Date:$

#include <stdio.h>
#include <string.h>
#include <sys/time.h>

#include "main.h"



/******************************************************************************
*
*	Function:	_port_a_in
*
*	Purpose:
*
*		Read the given port and report what we got.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _port_a_in(int fd)
{
	u8	bit;
	u8	data;
	int	errs	= 0;

	errs	+= dio40_gpio_a_in_get(fd, &data);

	for (bit = 0x80; bit; bit /= 2)
	{
		if (data & bit)
			printf("1");
		else
			printf("0");
	}

	errs	= errs ? 1 : 0;
	return(errs);
}



/******************************************************************************
*
*	Function:	_port_b_in
*
*	Purpose:
*
*		Read the given port and report what we got.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _port_b_in(int fd)
{
	u32	bit;
	u32	data;
	int	errs	= 0;

	errs	+= dio40_gpio_b_in_get(fd, &data);

	for (bit = 0x80000000; bit; bit /= 2)
	{
		if (data & bit)
			printf("1");
		else
			printf("0");
	}

	errs	= errs ? 1 : 0;
	return(errs);
}



/******************************************************************************
*
*	Function:	din_test
*
*	Purpose:
*
*		Perform a simple Digital Input test.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

int din_test(int fd)
{
	int	errs	= 0;
	int	i;

	label("Digital Input");
	printf("\n");

	errs	+= dio40_reset(fd);
	printf("  Port A    Port B\n");
	printf("  7------0  31-----------------------------0\n");
	printf("  ========  ================================\n");

	for (i = 0; i < 20; i++)
	{
		printf("  ");
		errs	+= _port_a_in(fd);
		printf("  ");
		errs	+= _port_b_in(fd);
		printf("\n");
		usleep(100000);
	}

	errs	= errs ? 1 : 0;
	label_level_inc();
	label("Results");
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	label_level_dec();
	return(errs);
}



