// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO40/legacy/DIO40_Linux_1.00.0_GSC_DN/driver/dio40.h $
// $Rev: 37244 $
// $Date:$

#ifndef __DIO40_H__
#define __DIO40_H__

#include "gsc_common.h"
#include "gsc_pci9656.h"



// #defines *******************************************************************

#define	DIO40_BASE_NAME						"dio40"

// IOCTL command codes
#define	DIO40_IOCTL_REG_READ				OS_IOCTL_RW(0, 12, gsc_reg_t)
#define	DIO40_IOCTL_REG_WRITE				OS_IOCTL_W (1, 12, gsc_reg_t)
#define	DIO40_IOCTL_REG_MOD					OS_IOCTL_W (2, 12, gsc_reg_t)
#define	DIO40_IOCTL_QUERY					OS_IOCTL_RW(3,  4, s32)


//*****************************************************************************
// DIO40_IOCTL_REG_READ
// DIO40_IOCTL_REG_WRITE
// DIO40_IOCTL_REG_MOD
//
#define DIO40_REG_ENCODE(s,o)				GSC_REG_ENCODE(GSC_REG_TYPE_BAR2,(s),(o))
// Parameter:	gsc_reg_t*
#define	DIO40_GSC_FRR						DIO40_REG_ENCODE(4,0x00)// Firmware Revision Register
#define	DIO40_GSC_BCR						DIO40_REG_ENCODE(4,0x04)// Board Control Register
#define	DIO40_GSC_BSR						DIO40_REG_ENCODE(4,0x08)// Board Status Register
#define	DIO40_GSC_CCAR						DIO40_REG_ENCODE(4,0x0C)
#define	DIO40_GSC_CCBR						DIO40_REG_ENCODE(4,0x10)
#define	DIO40_GSC_COAR						DIO40_REG_ENCODE(4,0x14)
#define	DIO40_GSC_COBR						DIO40_REG_ENCODE(4,0x18)
#define	DIO40_GSC_CIAR						DIO40_REG_ENCODE(4,0x1C)
#define	DIO40_GSC_CIBR						DIO40_REG_ENCODE(4,0x20)
#define	DIO40_GSC_LOR						DIO40_REG_ENCODE(4,0x30)

// This are from the updated FRR format.
#define	DIO40_GSC_FRR_FF_PCI				0x01
#define	DIO40_GSC_FRR_FF_PMC				0x02
#define	DIO40_GSC_FRR_FF_CPCI				0x03
#define	DIO40_GSC_FRR_FF_PC104P				0x04

//*****************************************************************************
// DIO40_IOCTL_QUERY
//
//	Parameter:	s32
//		Pass in a value from the list below.
//		The value returned is the answer to the query.

typedef enum
{
		DIO40_QUERY_COUNT,				// Number of query options.
		DIO40_QUERY_DEVICE_TYPE,		// Value from gsc_dev_type_t
		DIO40_QUERY_LAST
} dio40_query_t;

#define	DIO40_IOCTL_QUERY_ERROR			(-1)



#endif
