// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO40/legacy/DIO40_Linux_1.00.0_GSC_DN/driver/main.h $
// $Rev: 37244 $
// $Date:$

#ifndef __MAIN_H__
#define __MAIN_H__

#define	DEV_BAR_SHOW						0
#define	DEV_PCI_ID_SHOW						0

#include "dio40.h"

#include "gsc_common.h"
#include "gsc_main.h"




// #defines *******************************************************************

#define	DEV_VERSION							"3.0"
// 3.0	Updated to use the newer common driver sources.
//		Removed GNU notice from non-Linux specific files.
//		Removed Linux specific content from non-Linux specific source files.
//		White space cleanup.
//		Now using a spinlock rather than enabling and disabling interrupts.
//		The BAR code has been updated to include the data under a single structure.
//		The register definitions have been updated.
//		I/O services now pass around an os_mem_t structure instead of a buffer pointer.
//		White space cleanup.
//		Changed the arbitrary wait event callback argument to a void* type.
//		Modified to allow multiple apps to simultaneously access a single device.
//		Correct access to BAR0 and BAR1 (is RO, was RW).
//		Corrected the IOCTL code for the register write and mod services.
// 2.0	Reduced #include list in driver interface header.
//		Ported to use common source code.
//		Changed interface: dropped some services, use common structures
// 1.2	Updated for the 3.x kernel.
//		Updated to use the gsc_kernel[642].[ch] files.
//		Removed compile waring regarding copy_from_user() call.
//		Expanded version number to include the version from gsc_common.
// 1.01	Ported the driver to newer 2.6 and 64-bit kernels.
// 1.00	Initial release.

#define	DEV_MODEL							"DIO40"	// Upper case form of the below.
#define	DEV_NAME							"dio40"	// MUST AGREE WITH DSI16WRC_BASE_NAME

#define	GSC_IRQ_NOT_USED



// data types *****************************************************************

struct _dev_data_t
{
	os_pci_t*			pci;			// The kernel PCI device descriptor.
	os_spinlock_t		spinlock;		// Control ISR access.
	os_sem_t			sem;			// Control thread access.
	gsc_dev_type_t		board_type;		// Corresponds to basic board type.
	const char*			model;			// Base model number in upper case.
	int					board_index;	// Index of the board being accessed.
	int					users;			// Number of currently active open() requests.
	int					share;			// Were we opened in shared mode?

	gsc_bar_t			bar;			// device register mappings

	struct
	{
		VADDR_T			gsc_bcr_32;		// Board Control Register
	} vaddr;
};



#endif
