// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO40/legacy/DIO40_Linux_1.00.0_GSC_DN/lib/led.c $
// $Rev: 32426 $
// $Date:$

#include "dio40_lib.h"



/******************************************************************************
*
*	Function:	dio40_led_get
*
*	Purpose:
*
*		Return the status of the LEDs.
*
*	Arguments:
*
*		fd		The file descriptor of the device to access.
*
*		on		Tell the caller which LEDs are on. If a bit is set, then
*				the LED is on.
*
*	Returned:
*
*		0		All went well.
*		else	The errno value for the error that occurrred.
*
******************************************************************************/

int dio40_led_get(int fd, u8* on)
{
	int	err;
	u32	lor;

	err	= dio40_reg_read(fd, DIO40_GSC_LOR, &lor);

	if (on)
		on[0]	= (u8) (lor & 0xFF);

	return(err);
}



/******************************************************************************
*
*	Function:	dio40_led_mod
*
*	Purpose:
*
*		Update the state of some of the LEDs.
*
*	Arguments:
*
*		fd		The file descriptor of the device to access.
*
*		on		If a bit is set, then the LED is turned on.
*
*		mask	The set of LEDs to access. If a bit is set here, then the LED
*				is accessed. If the bit is not set, then it is unmodified.
*
*	Returned:
*
*		0		All went well.
*		else	The errno value for the error that occurrred.
*
******************************************************************************/

int dio40_led_mod(int fd, u8 on, u8 mask)
{
	int	err;

	err	= dio40_reg_mod(fd, DIO40_GSC_LOR, on, mask);
	return(err);
}



/******************************************************************************
*
*	Function:	dio40_led_set
*
*	Purpose:
*
*		Update the state of the LEDs.
*
*	Arguments:
*
*		fd		The file descriptor of the device to access.
*
*		on		If a bit is set, then the LED is turned on. If the bit is
*				clear, then it is turned off.
*
*	Returned:
*
*		0		All went well.
*		else	The errno value for the error that occurrred.
*
******************************************************************************/

int dio40_led_set(int fd, u8 on)
{
	int	err;

	err	= dio40_reg_mod(fd, DIO40_GSC_LOR, on, 0xFF);
	return(err);
}



