// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO40/legacy/DIO40_Linux_1.00.0_GSC_DN/sbtest/latch.c $
// $Rev: 32587 $
// $Date:$

#include <stdio.h>
#include <string.h>
#include <sys/time.h>

#include "main.h"



/******************************************************************************
*
*	Function:	_a_dir_get_test
*
*	Purpose:
*
*		Perform a test of the dio40_gpio_a_dir_get() library call.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _a_dir_get_test(int fd)
{
	u32	ccar;
	u8	dir;
	int	errs	= 0;

	label("dio40_gpio_a_dir_get");

	for (ccar = 1; ccar <= 0x80; ccar *= 2)
	{
		errs	+= dio40_reg_write(fd, DIO40_GSC_CCAR, ccar);
		errs	+= dio40_gpio_a_dir_get(fd, &dir);
		errs	+= (dir == ccar) ? 0 : 1;
	}

	errs	+= dio40_reg_write(fd, DIO40_GSC_CCAR, 0);
	errs	= errs ? 1 : 0;
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}



/******************************************************************************
*
*	Function:	_a_dir_mod_test
*
*	Purpose:
*
*		Perform a test of the dio40_gpio_a_dir_mod() library call.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _a_dir_mod_test(int fd)
{
	u32	ccar;
	u8	dir;
	int	errs	= 0;

	label("dio40_gpio_a_dir_mod");

	for (dir = 1; dir; dir *= 2)
	{
		errs	+= dio40_reg_write(fd, DIO40_GSC_CCAR, 0);
		errs	+= dio40_gpio_a_dir_mod(fd, dir, dir);
		errs	+= dio40_reg_read(fd, DIO40_GSC_CCAR, &ccar);
		errs	+= (dir == ccar) ? 0 : 1;
	}

	errs	+= dio40_reg_write(fd, DIO40_GSC_CCAR, 0);
	errs	= errs ? 1 : 0;
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}



/******************************************************************************
*
*	Function:	_a_dir_set_test
*
*	Purpose:
*
*		Perform a test of the dio40_gpio_a_dir_set() library call.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _a_dir_set_test(int fd)
{
	u32	ccar;
	u8	dir;
	int	errs	= 0;

	label("dio40_gpio_a_dir_set");

	for (dir = 1; dir; dir *= 2)
	{
		errs	+= dio40_gpio_a_dir_set(fd, dir);
		errs	+= dio40_reg_read(fd, DIO40_GSC_CCAR, &ccar);
		errs	+= (dir == ccar) ? 0 : 1;
	}

	errs	+= dio40_reg_write(fd, DIO40_GSC_CCAR, 0);
	errs	= errs ? 1 : 0;
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}



/******************************************************************************
*
*	Function:	_a_out_get_test
*
*	Purpose:
*
*		Perform a test of the dio40_gpio_a_out_get() library call.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _a_out_get_test(int fd)
{
	u32	coar;
	u8	data;
	int	errs	= 0;

	label("dio40_gpio_a_out_get");

	for (coar = 1; coar <= 0x80; coar *= 2)
	{
		errs	+= dio40_reg_write(fd, DIO40_GSC_COAR, coar);
		errs	+= dio40_gpio_a_out_get(fd, &data);
		errs	+= (data == coar) ? 0 : 1;
	}

	errs	+= dio40_reg_write(fd, DIO40_GSC_COAR, 0);
	errs	= errs ? 1 : 0;
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}



/******************************************************************************
*
*	Function:	_a_out_mod_test
*
*	Purpose:
*
*		Perform a test of the dio40_gpio_a_out_mod() library call.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _a_out_mod_test(int fd)
{
	u32	coar;
	u8	data;
	int	errs	= 0;

	label("dio40_gpio_a_out_mod");

	for (data = 1; data; data *= 2)
	{
		errs	+= dio40_reg_write(fd, DIO40_GSC_COAR, 0);
		errs	+= dio40_gpio_a_out_mod(fd, data, data);
		errs	+= dio40_reg_read(fd, DIO40_GSC_COAR, &coar);
		errs	+= (data == coar) ? 0 : 1;
	}

	errs	+= dio40_reg_write(fd, DIO40_GSC_COAR, 0);
	errs	= errs ? 1 : 0;
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}



/******************************************************************************
*
*	Function:	_a_out_set_test
*
*	Purpose:
*
*		Perform a test of the dio40_gpio_a_out_set() library call.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _a_out_set_test(int fd)
{
	u32	coar;
	u8	data;
	int	errs	= 0;

	label("dio40_gpio_a_out_set");

	for (data = 1; data; data *= 2)
	{
		errs	+= dio40_gpio_a_out_set(fd, data);
		errs	+= dio40_reg_read(fd, DIO40_GSC_COAR, &coar);
		coar	&= 0xFF;
		errs	+= (data == coar) ? 0 : 1;
	}

	errs	+= dio40_reg_write(fd, DIO40_GSC_COAR, 0);
	errs	= errs ? 1 : 0;
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}



/******************************************************************************
*
*	Function:	_b_dir_get_test
*
*	Purpose:
*
*		Perform a test of the dio40_gpio_b_dir_get() library call.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _b_dir_get_test(int fd)
{
	u32	ccbr;
	u32	dir;
	int	errs	= 0;

	label("dio40_gpio_b_dir_get");

	for (ccbr = 1; ccbr; ccbr *= 2)
	{
		errs	+= dio40_reg_write(fd, DIO40_GSC_CCBR, ccbr);
		errs	+= dio40_gpio_b_dir_get(fd, &dir);
		errs	+= (dir == ccbr) ? 0 : 1;
	}

	errs	+= dio40_reg_write(fd, DIO40_GSC_CCBR, 0);
	errs	= errs ? 1 : 0;
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}



/******************************************************************************
*
*	Function:	_b_dir_mod_test
*
*	Purpose:
*
*		Perform a test of the dio40_gpio_b_dir_mod() library call.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _b_dir_mod_test(int fd)
{
	u32	ccbr;
	u32	dir;
	int	errs	= 0;

	label("dio40_gpio_b_dir_mod");

	for (dir = 1; dir; dir *= 2)
	{
		errs	+= dio40_reg_write(fd, DIO40_GSC_CCBR, 0);
		errs	+= dio40_gpio_b_dir_mod(fd, dir, dir);
		errs	+= dio40_reg_read(fd, DIO40_GSC_CCBR, &ccbr);
		errs	+= (dir == ccbr) ? 0 : 1;
	}

	errs	+= dio40_reg_write(fd, DIO40_GSC_CCBR, 0);
	errs	= errs ? 1 : 0;
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}



/******************************************************************************
*
*	Function:	_b_dir_set_test
*
*	Purpose:
*
*		Perform a test of the dio40_gpio_b_dir_set() library call.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _b_dir_set_test(int fd)
{
	u32	ccbr;
	u32	dir;
	int	errs	= 0;

	label("dio40_gpio_b_dir_set");

	for (dir = 1; dir; dir *= 2)
	{
		errs	+= dio40_gpio_b_dir_set(fd, dir);
		errs	+= dio40_reg_read(fd, DIO40_GSC_CCBR, &ccbr);
		errs	+= (dir == ccbr) ? 0 : 1;
	}

	errs	+= dio40_reg_write(fd, DIO40_GSC_CCBR, 0);
	errs	= errs ? 1 : 0;
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}



/******************************************************************************
*
*	Function:	_b_out_get_test
*
*	Purpose:
*
*		Perform a test of the dio40_gpio_b_out_get() library call.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _b_out_get_test(int fd)
{
	u32	cobr;
	u32	data;
	int	errs	= 0;

	label("dio40_gpio_b_out_get");

	for (cobr = 1; cobr; cobr *= 2)
	{
		errs	+= dio40_reg_write(fd, DIO40_GSC_COBR, cobr);
		errs	+= dio40_gpio_b_out_get(fd, &data);
		errs	+= (data == cobr) ? 0 : 1;
	}

	errs	+= dio40_reg_write(fd, DIO40_GSC_COBR, 0);
	errs	= errs ? 1 : 0;
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}



/******************************************************************************
*
*	Function:	_b_out_mod_test
*
*	Purpose:
*
*		Perform a test of the dio40_gpio_b_out_mod() library call.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _b_out_mod_test(int fd)
{
	u32	cobr;
	u32	data;
	int	errs	= 0;

	label("dio40_gpio_b_out_mod");

	for (data = 1; data; data *= 2)
	{
		errs	+= dio40_reg_write(fd, DIO40_GSC_COBR, 0);
		errs	+= dio40_gpio_b_out_mod(fd, data, data);
		errs	+= dio40_reg_read(fd, DIO40_GSC_COBR, &cobr);
		errs	+= (data == cobr) ? 0 : 1;
	}

	errs	+= dio40_reg_write(fd, DIO40_GSC_COBR, 0);
	errs	= errs ? 1 : 0;
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}



/******************************************************************************
*
*	Function:	_b_out_set_test
*
*	Purpose:
*
*		Perform a test of the dio40_gpio_b_out_set() library call.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _b_out_set_test(int fd)
{
	u32	cobr;
	u32	data;
	int	errs	= 0;

	label("dio40_gpio_b_out_set");

	for (data = 1; data; data *= 2)
	{
		errs	+= dio40_gpio_b_out_set(fd, data);
		errs	+= dio40_reg_read(fd, DIO40_GSC_COBR, &cobr);
		errs	+= (data == cobr) ? 0 : 1;
	}

	errs	+= dio40_reg_write(fd, DIO40_GSC_COBR, 0);
	errs	= errs ? 1 : 0;
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}



/******************************************************************************
*
*	Function:	_latch_bit_test
*
*	Purpose:
*
*		Perform output latch testing on the given register latch.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*		reg		The identifier of the register.
*
*		name	The name of the register to access.
*
*		latch	The index of the output latch to test.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _latch_bit_test(int fd, u32 reg, const char* name, int latch)
{
	u32	bit		= 1UL << latch;
	int	errs	= 0;
	u32	value;

	label(name);

	// Set the bit in a field of zeros and make sure it is set.
	errs	+= dio40_reg_write(fd, DIO40_GSC_COAR, 0x00000000);
	errs	+= dio40_reg_write(fd, DIO40_GSC_COBR, 0x00000000);
	errs	+= dio40_reg_mod(fd, reg, bit, bit);
	errs	+= dio40_reg_read(fd, reg, &value);
	errs	+= (value & bit) ? 0 : 1;

	// Clear the bit in a field of ones and make sure it is clear.
	errs	+= dio40_reg_write(fd, DIO40_GSC_COAR, 0x000000FF);
	errs	+= dio40_reg_write(fd, DIO40_GSC_COBR, 0xFFFFFFFF);
	errs	+= dio40_reg_mod(fd, reg, 0, bit);
	errs	+= dio40_reg_read(fd, reg, &value);
	errs	+= (value & bit) ? 1 : 0;

	// Set the bit and make sure it is cleared by a board reset.
	errs	+= dio40_reg_mod(fd, reg, bit, bit);
	errs	+= dio40_reset(fd);
	errs	+= dio40_reg_read(fd, reg, &value);
	errs	+= (value & bit) ? 1 : 0;

	errs	= errs ? 1 : 0;
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}



/******************************************************************************
*
*	Function:	_latch_reg_test
*
*	Purpose:
*
*		Perform output latch tests on the given register.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*		name	The name of the register.
*
*		reg		The identifier of the register.
*
*		latches	The number of output latched in the registers.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _latch_reg_test(int fd, const char* name, u32 reg, int latches)
{
	char	buf[16];
	int		errs	= 0;
	int		i;

	label(name);
	printf("\n");
	label_level_inc();

	for (i = 0; i < latches; i++)
	{
		sprintf(buf, "D%d", i);
		errs	+= _latch_bit_test(fd, reg, buf, i);
	}

	label_level_dec();
	return(errs);
}



/******************************************************************************
*
*	Function:	latch_test
*
*	Purpose:
*
*		Perform output latch tests.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

int latch_test(int fd)
{
	int	errs	= 0;

	label("Output Latch Tests (board)");
	printf("\n");
	label_level_inc();

	errs	+= _latch_reg_test(fd, "COAR", DIO40_GSC_CCAR, 8);
	errs	+= _latch_reg_test(fd, "COBR", DIO40_GSC_CCBR, 32);

	label_level_dec();

	label("Output Latch Tests (library)");
	printf("\n");
	label_level_inc();

	errs	+= _a_dir_get_test(fd);
	errs	+= _a_dir_mod_test(fd);
	errs	+= _a_dir_set_test(fd);
	errs	+= _a_out_get_test(fd);
	errs	+= _a_out_mod_test(fd);
	errs	+= _a_out_set_test(fd);

	errs	+= _b_dir_get_test(fd);
	errs	+= _b_dir_mod_test(fd);
	errs	+= _b_dir_set_test(fd);
	errs	+= _b_out_get_test(fd);
	errs	+= _b_out_mod_test(fd);
	errs	+= _b_out_set_test(fd);

	label_level_dec();
	return(errs);
}



